Package org.apache.storm.streams.windowing

# Class BaseWindow<L,I>

java.lang.Object
org.apache.storm.streams.windowing.BaseWindow<L,I>

All Implemented Interfaces:
  `Serializable`, `Window<L,I>`

Direct Known Subclasses:
  `SlidingWindows`, `TumblingWindows`

public abstract class BaseWindow<L,I> extends Object implements Window<L,I>

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected BaseWindowedBolt.Duration`
  `lag`
  `protected String`
  `lateTupleStream`
  `protected String`
  `timestampField`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BaseWindow()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `equals(Object o)`
  `BaseWindowedBolt.Duration`
  `getLag()`
  The maximum time lag of the tuple timestamp in milliseconds.
  `String`
  `getLateTupleStream()`
  The name of the stream where late arriving tuples should be emitted.
  `String`
  `getTimestampField()`
  The name of the field in the tuple that contains the timestamp when the event occurred as a long value.
  `int`
  `hashCode()`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.apache.storm.streams.windowing.Window

  `getSlidingInterval, getWindowLength`

- ## Field Details

  - ### timestampField

    protected String timestampField

  - ### lateTupleStream

    protected String lateTupleStream

  - ### lag

    protected BaseWindowedBolt.Duration lag

- ## Constructor Details

  - ### BaseWindow

    public BaseWindow()

- ## Method Details

  - ### getTimestampField

    public String getTimestampField()
    Description copied from interface: `Window`
    The name of the field in the tuple that contains the timestamp when the event occurred as a long value. This is used of event-time based processing. If this config is set and the field is not present in the incoming tuple, an `IllegalArgumentException` will be thrown.
    Specified by:
      `getTimestampField` in interface `Window<L,I>`
    Returns:
      the timestamp field.

  - ### getLateTupleStream

    public String getLateTupleStream()
    Description copied from interface: `Window`
    The name of the stream where late arriving tuples should be emitted. If this is not provided, the late tuples would be discarded.
    Specified by:
      `getLateTupleStream` in interface `Window<L,I>`
    Returns:
      the name of the stream used to emit late tuples on

  - ### getLag

    public BaseWindowedBolt.Duration getLag()
    Description copied from interface: `Window`
    The maximum time lag of the tuple timestamp in milliseconds. It means that the tuple timestamps cannot be out of order by more than this amount.
    Specified by:
      `getLag` in interface `Window<L,I>`
    Returns:
      the lag

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Overrides:
      `hashCode` in class `Object`